#ifndef WRITEPIN_H
#define WRITEPIN_H
#include <avr/io.h>

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Warray-bounds"
inline void writePin(volatile unsigned char *port, const unsigned char pin, const bool state) //waste 2 cycles
{
	*port  &= ~(1 << pin);
	if(state) *port |= (1 << pin);
}

inline void setBit( volatile unsigned char *reg, const unsigned char bit, bool value )
{
	writePin(reg, bit, value);
}


inline void setDirection( volatile unsigned char *portDirReg, const unsigned char pin, bool makeOutput )
{
	writePin(portDirReg, pin, makeOutput);
}

inline bool readPin( volatile unsigned char *inPort, const unsigned char pin)
{
	return (bool) (*inPort & (1 << pin));
}
#pragma GCC diagnostic pop

#endif
